<?php

/*
Plugin Name: Admin category search pro
Description: This plugin adds a search tab to the category boxes on admin add / edit pages, thus making it easy to search a category in a very long list
Version: 0.5
Author: Atilla Ordog
Author URI: http://attilaordog.wordpress.com/
*/

function register_admin_search_category_custom_script($hook)
{	
	if ( 'post.php' != $hook && $hook != 'post-new.php' )
	{
		return;
	}	
	
	wp_enqueue_style('admin_category_search_autocomplete_style', site_url().'/wp-content/plugins/wp-admin-category-search-pro/css/autocomplete.css', null, true);
	
	wp_enqueue_script('admin_category_search_autocomplete', site_url().'/wp-content/plugins/wp-admin-category-search-pro/js/jquery.autocomplete.min.js', null, true);
	
	wp_enqueue_script('admin_category_search', site_url().'/wp-content/plugins/wp-admin-category-search-pro/js/script.js', null, true);
}

add_action( 'admin_enqueue_scripts', 'register_admin_search_category_custom_script', 0, 1);